=begin

= Ruby/Asp Install Guide

[((<Index|URL:index.en.html>))
|((<RD format|URL:install.en.rd>))]

* ((<Require>))
* ((<Install>))
* ((<Use Ruby-Asp>))
* ((<Config>))

== Require

Ruby/Asp require ((<libxml|URL:http://www.rubynet.org>)), ((<libxslt|URL:http://www.rubynet.org>)), ((<mod_ruby|URL:http://modruby.net>)) and (of course) ((<Ruby|URL:http://www.ruby-lang.org/en/>)) ;)


== Install

Install Ruby/Asp like this:

  $ tar zxvf ruby-asp_x.y.z.tar.gz
  $ cd ruby-asp
  $ ruby install.rb config 
  $ ruby install.rb setup 
  # ruby install.rb install

== Use Ruby-Asp

Add these lines to httpd.conf or in a .htaccess file

  RubySetEnv Global /var/www/global-asa
  RubyRequire apache/aspruby-run
  <Files ~ (\.asp)>
    SetHandler ruby-object
    RubyHandler Apache::AspRun.instance
  </Files>

== Config

--- Global
      Global is the nerve center of a Ruby/Asp application, in which the global.asa may reside defining the web application's event handlers.

--- MailHost
      The mail host is the smtp server that the below Mail config directives will use when sending their emails. Default : localhost.

--- MailPort
      SMTP port. Default : 25.

--- MailErrorsFrom
      Default NONE, set this to specify the default mail address placed in the From: mail header for server errors.

--- MailErrorsTo
      No default, if set, ASP server errors, error code 500, that result while compiling or running scripts under Ruby/Asp will automatically be emailed to the email address set for this config.

--- ErrorFile
      URI for error redirection.

--- StateDir
      State files for ASP application go to this directory. Default : /tmp

--- SessionID
      Cookie name reserved for session management. Default : session-id.

--- SessionTimeout
      Default 20 minutes, when a user's session has been inactive for this period of time, the Session_OnEnd event is run, if defined, for that session, and the contents of that session are destroyed.

=end
